 vim-go cookbook
=============================

vim-go (0.1.1) Installs/Configures vim-go

Installs vim-go in the .vimrc for each user based on the users data_bag

If `node[:vim_go][:user_databag]` is set it will install for all the users listed in the databag that have `vim: true`.

The users data_bag format is expected to be in the format of the `fnichol/chef-user` or `opscode-cookbooks/users` cookbooks".
Only the `"id"` and `"vim"` keys are used by this cookbook.

Right now it also installs the following:

* git
* golang
* vim-nox
* pathogen.vim
* vim-go

It also sets up a basic .vimrc suitable for go development

Will not overwrite:

* `~/.vim/bundle/vim-go`
* `~/.vim/autoload/pathogen.vim`

Only tested with ubuntu 14.04 but probably will work elsewhere.



Requirements
------------

### Platforms

`ubuntu >= 14.04`

### Dependencies

`apt >= 0.0.0`

`git >= 0.0.0`

`golang >= 0.0.0`

`vim >= 0.0.0`


Attributes
----------

    vim_go/users_databag
      calculated: false
      choice: []
      default: users
      description: Name of the users data_bag
      display_name: Users Databag
      type: string
      recipes: []
      required: optional

    vim_go/install_vim
      calculated: false
      choice: []
      default: true
      description: Install Vim
      display_name: Install Vim
      type: boolean
      recipes: []
      required: optional


Recipes
-------

    vim_go::default
      Does all the work to install vim-go and dependencies

Testing and Utility
-------
    <Rake::Task default => [prepare, test]>
      Install required Gems and Cookbook then run all tests

    <Rake::Task direnv => []>
      Setup direnv by updating path to have chefdk first and remove any rvm directories from the PATH

    <Rake::Task integration => [integration:kitchen]>

    <Rake::Task integration:kitchen => []>

    <Rake::Task kitchen:all => [default-ubuntu-1404]>
      Run all test instances

    <Rake::Task kitchen:default-ubuntu-1404 => []>
      Run default-ubuntu-1404 test instance

    <Rake::Task prepare => [prepare:bundle, prepare:berks]>
      Install required Gems and Cookbooks

    <Rake::Task prepare:berks => []>

    <Rake::Task prepare:bundle => []>

    <Rake::Task readme => []>
      Generate the Readme.md file.

    <Rake::Task spec => [unit]>

    <Rake::Task style => [style:foodcritic, style:rubocop]>
      Run all style checks

    <Rake::Task style:foodcritic => []>

    <Rake::Task style:rubocop => []>

    <Rake::Task test => [style, unit, integration]>
      Run all tests

    <Rake::Task unit => [unit:chefspec]>
      Run all unit tests

    <Rake::Task unit:chefspec => []>

    <Rake::Task yard => []>
      Generate YARD Documentation

License and Authors
------------------

The following engineers have contributed to this code:
 * [Robert J. Berger](https://github.com/rberger) - 10 commits

Copyright:: 2015, [Mist Systems, LLC](http://www.mistsys.com)

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

Contributing
------------

We welcome contributed improvements and bug fixes via the usual workflow:

1. Fork this repository
2. Create your feature branch (`git checkout -b my-new-feature`)
3. Commit your changes (`git commit -am 'Add some feature'`)
4. Push to the branch (`git push origin my-new-feature`)
5. Create a new pull request
